OpenJPEG: t2.h File Reference

OpenJPEG 2.5.4

Data Structures | Typedefs
t2.h File Reference

Implementation of a tier-2 coding (packetization of code-block data) (T2). More...

Go to the source code of this file.

## Data Structures
struct | opj_t2
| Tier-2 coding. More...

## Typedefs
typedef struct opj_t2 | opj_t2_t
| Tier-2 coding.

## Functions
Exported functions
OPJ_BOOL | opj_t2_encode_packets (opj_t2_t *t2, OPJ_UINT32 tileno, opj_tcd_tile_t *tile, OPJ_UINT32 maxlayers, OPJ_BYTE *dest, OPJ_UINT32 *p_data_written, OPJ_UINT32 len, opj_codestream_info_t *cstr_info, opj_tcd_marker_info_t *p_marker_info, OPJ_UINT32 tpnum, OPJ_INT32 tppos, OPJ_UINT32 pino, J2K_T2_MODE t2_mode, opj_event_mgr_t *p_manager)
| Encode the packets of a tile to a destination buffer.
OPJ_BOOL | opj_t2_decode_packets (opj_tcd_t *tcd, opj_t2_t *t2, OPJ_UINT32 tileno, opj_tcd_tile_t *tile, OPJ_BYTE *src, OPJ_UINT32 *p_data_read, OPJ_UINT32 len, opj_codestream_index_t *cstr_info, opj_event_mgr_t *p_manager)
| Decode the packets of a tile from a source buffer.
opj_t2_t * | opj_t2_create (opj_image_t *p_image, opj_cp_t *p_cp)
| Creates a Tier 2 handle.
void | opj_t2_destroy (opj_t2_t *t2)
| Destroy a T2 handle.

## Detailed Description

Implementation of a tier-2 coding (packetization of code-block data) (T2).

## Typedef Documentation

## ◆ opj_t2_t

typedef struct opj_t2 opj_t2_t

Tier-2 coding.

## Function Documentation

## ◆ opj_t2_create()

opj_t2_t * opj_t2_create | ( | opj_image_t * | p_image,
|  | opj_cp_t * | p_cp )

Creates a Tier 2 handle.

Parameters

  p_image | Source or destination image
  p_cp | Image coding parameters.

Returns
  a new T2 handle if successful, NULL otherwise.

References opj_t2::cp, opj_t2::image, and opj_calloc().

Referenced by opj_tcd_rateallocate(), opj_tcd_t2_decode(), and opj_tcd_t2_encode().

## ◆ opj_t2_decode_packets()

OPJ_BOOL opj_t2_decode_packets | ( | opj_tcd_t * | tcd,
|  | opj_t2_t * | t2,
|  | OPJ_UINT32 | tileno,
|  | opj_tcd_tile_t * | tile,
|  | OPJ_BYTE * | src,
|  | OPJ_UINT32 * | p_data_read,
|  | OPJ_UINT32 | len,
|  | opj_codestream_index_t * | cstr_info,
|  | opj_event_mgr_t * | p_manager )

Decode the packets of a tile from a source buffer.

Parameters

  tcd | TCD handle
  t2 | T2 handle
  tileno | number that identifies the tile for which to decode the packets
  tile | tile for which to decode the packets
  src | FIXME DOC
  p_data_read | the source buffer
  len | length of the source buffer
  cstr_info | FIXME DOC
  p_manager | the user event manager

Returns
  FIXME DOC

References opj_tcd_band::bandno, opj_tcd_resolution::bands, opj_pi_iterator::compno, opj_image::comps, opj_tcd_tile::comps, opj_t2::cp, opj_packet_info::end_ph_pos, opj_packet_info::end_pos, opj_t2::image, JAS_FPRINTF, opj_pi_iterator::layno, opj_cp::m_enc, opj_cp::m_specific_param, opj_encoding_param::m_tp_on, opj_tcd_tilecomp::minimum_num_resolutions, opj_tcp::num_layers_to_decode, opj_tcd_resolution::numbands, opj_image::numcomps, opj_tcp::numpocs, OPJ_ARG_NOT_USED, OPJ_FALSE, opj_free(), opj_malloc(), opj_pi_create_decode(), opj_pi_destroy(), opj_pi_next(), OPJ_PROG_UNKNOWN, opj_t2_decode_packet(), opj_t2_skip_packet(), opj_tcd_is_subband_area_of_interest(), OPJ_TRUE, opj_uint_max(), opj_pi_iterator::poc, opj_tcd_band::precincts, opj_pi_iterator::precno, opj_poc::prg, opj_poc::prg1, opj_pi_iterator::resno, opj_image_comp::resno_decoded, opj_tcd_tilecomp::resolutions, opj_packet_info::start_pos, opj_cp::tcps, opj_codestream_index::tile_index, opj_tcd_precinct::x0, opj_tcd_precinct::x1, opj_tcd_precinct::y0, and opj_tcd_precinct::y1.

Referenced by opj_tcd_t2_decode().

## ◆ opj_t2_destroy()

void opj_t2_destroy | ( | opj_t2_t * | t2 | ) |

Destroy a T2 handle.

Parameters

  t2 | T2 handle to destroy

References opj_free().

Referenced by opj_tcd_rateallocate(), opj_tcd_t2_decode(), and opj_tcd_t2_encode().

## ◆ opj_t2_encode_packets()

OPJ_BOOL opj_t2_encode_packets | ( | opj_t2_t * | t2,
|  | OPJ_UINT32 | tileno,
|  | opj_tcd_tile_t * | tile,
|  | OPJ_UINT32 | maxlayers,
|  | OPJ_BYTE * | dest,
|  | OPJ_UINT32 * | p_data_written,
|  | OPJ_UINT32 | len,
|  | opj_codestream_info_t * | cstr_info,
|  | opj_tcd_marker_info_t * | p_marker_info,
|  | OPJ_UINT32 | tpnum,
|  | OPJ_INT32 | tppos,
|  | OPJ_UINT32 | pino,
|  | J2K_T2_MODE | t2_mode,
|  | opj_event_mgr_t * | p_manager )

Encode the packets of a tile to a destination buffer.

Parameters

  t2 | T2 handle
  tileno | number of the tile encoded
  tile | the tile for which to write the packets
  maxlayers | maximum number of layers
  dest | the destination buffer
  p_data_written | FIXME DOC
  len | the length of the destination buffer
  cstr_info | Codestream information structure
  p_marker_info | Marker information structure
  tpnum | Tile part number of the current tile
  tppos | The position of the tile part flag in the progression order
  pino | FIXME DOC
  t2_mode | If == THRESH_CALC In Threshold calculation ,If == FINAL_PASS Final pass
  p_manager | the user event manager

References opj_t2::cp, opj_tile_info::end_header, opj_packet_info::end_ph_pos, opj_packet_info::end_pos, opj_t2::image, opj_codestream_info::index_write, opj_pi_iterator::layno, opj_cp::m_enc, opj_encoding_param::m_max_comp_size, opj_cp::m_specific_param, opj_encoding_param::m_tp_on, opj_tcd_marker_info::need_PLT, opj_image::numcomps, opj_tcp::numpocs, OPJ_FALSE, opj_get_encoding_packet_count(), opj_malloc(), opj_pi_create_encode(), opj_pi_destroy(), opj_pi_initialise_encode(), opj_pi_next(), OPJ_PROFILE_CINEMA_4K, OPJ_PROG_UNKNOWN, opj_t2_encode_packet(), OPJ_TRUE, opj_tcd_marker_info::p_packet_size, opj_tile_info::packet, opj_tcd_marker_info::packet_count, opj_codestream_info::packno, opj_tcd_tile::packno, opj_tcp::POC, opj_pi_iterator::poc, opj_poc::prg, opj_cp::rsiz, opj_packet_info::start_pos, opj_cp::tcps, THRESH_CALC, and opj_codestream_info::tile.

Referenced by opj_tcd_rateallocate(), and opj_tcd_t2_encode().